function [f,g,x] = T2(x,constseq,stage)
if nargin == 0
    prob.nx = 2;
    prob.nf = 1;
    prob.ng = 3;
    prob.range = cell(1, prob.nx);
    prob.range{1} = Range('range', [-1,1.5]);
    prob.range{2} = Range('range', [-1,0.05]);
    f = prob;
else
    [f,g] = T2_true(double(x),constseq,stage);
end
return


function [f,g] = T2_true(x,constseq,stage)
c=0.2;
A=[1 0.5 0.5];
f=[ 0.5 0.5 0.5];
phi=[0 0.8 0.5];
x_loc=1.433722480640840;
y_loc=0.05;
x_c=-0.067190052101144;
%Put the constraints functions below
for i=1:size(constseq,2)
    switch constseq(i)
        case 1
            g(1)= (A(1)*cos(2*pi*f(1)*x(1)^3-pi/2+phi(1))^2-x(2)-c);
        case 2
            g(2)= (A(2)*cos(2*pi*f(2)*x(1)^3-pi/2+phi(2))^2-x(2)-c);
        case 3
            g(3)= (A(3)*cos(2*pi*f(3)*x(1)-pi/2+phi(3))-x(2)-c);
    end
    if(~strcmp(stage,'init') && (g(constseq(i)))>0)
        for j=(i+1):size(constseq,2)
            g(constseq(j))=inf;
        end
        break
    end
end
%Place the objective function in below
if(sum(max(g,0)==0)==size(g,2))
%    f=sin(2*pi*0.5*(x(1)-x_loc)^2+(x(2))^2-pi/2+5);
% f=(x(1)^2+x(2)^2)/4000-cos(20*x(1))*cos(20*x(2)/sqrt(2))+0.5;
f=10*2+(x(1)^2-10*cos(3*pi*x(1)))+(x(2)^2-20*cos(3*pi*x(2)));
else
    f=NaN;
end
return
