function [f,g,x] = g11(x,constseq,stage)
if nargin == 0
    prob.nx = 2;
    prob.nf = 1;
    prob.ng = 2;
    prob.range = {Range('range', [-1,1]), Range('range', [-1,1])};
    f = prob;
else
    [f,g] = g11_true(double(x),constseq,stage);
end
return


function [f,g] = g11_true(x,constseq,stage)
eps = 1.e-3;
for i=1:size(constseq,2)
    switch constseq(i)
        case 1
            tmp1 = x(2) - x(1)^2;
            g(1) = -(tmp1 + eps);
        case 2
            tmp1 = x(2) - x(1)^2;
            g(2) = -(eps - tmp1);
    end
    if(~strcmp(stage,'init') && (g(constseq(i)))>0)
        for j=(i+1):size(constseq,2)
            g(constseq(j))=inf;
        end
        break
    end
end
if(sum(max(g,0)==0)==size(g,2))
    f = x(1)^2 + (x(2)-1)^2;
else
    f=NaN;
end
return
