function [f,g,x] = g13(x,constseq,stage)
if nargin == 0
    prob.nx = 5;
    prob.nf = 1;
    prob.ng = 3;
    prob.range = cell(1, prob.nx);
    prob.range{1} = Range('range', [-2.3,2.3]);
    prob.range{2} = Range('range', [-2.3,2.3]);
    for i = 3:prob.nx
        prob.range{i} = Range('range', [-3.2,3.2]);
    end
    f = prob;
else
    [f,g] = g13_true(double(x),constseq,stage);
end
return


function [f,g] = g13_true(x,constseq,stage)
eps = 1.e-5;
for i=1:size(constseq,2)
    switch constseq(i)
        case 1
            tmp1 = x*x' - 10;
            g(1) = abs(tmp1)-eps;
        case 2
            tmp2 = x(2)*x(3) - 5*x(4)*x(5);
            g(2) = abs(tmp2)-eps;
        case 3
            tmp3 = x(1)^3 + x(2)^3 + 1;
            g(3) = abs(tmp3)-eps;
    end
    if(~strcmp(stage,'init') && (g(constseq(i)))>0)
        for j=(i+1):size(constseq,2)
            g(constseq(j))=inf;
        end
        break
    end
end
if(sum(max(g,0)==0)==size(g,2) || strcmp(stage,'init'))
    f = exp(prod(x));
else
    f=NaN;
end

return
