function [f,g,x] = g2(x,constseq,stage)
if nargin == 0
    prob.nx = 20;
    prob.nf = 1;
    prob.ng = 2;
    prob.range = cell(1, prob.nx);
    for i = 1:prob.nx
        prob.range{i} = Range('range', [0,10]);
    end
    f = prob;
else
    [f,g] = g2_true(double(x),constseq,stage);
end
return


function [f,g] = g2_true(x,constseq,stage)


for i=1:size(constseq,2)
    switch constseq(i)
        case 1
            g(1) = -(prod(x) - 0.75);
        case 2
            g(2) = -(7.5*length(x) - sum(x));
    end
    if(~strcmp(stage,'init') && (g(constseq(i)))>0)
        for j=(i+1):size(constseq,2)
            g(constseq(j))=inf;
        end
        break
    end
end
%objective function
if(sum(max(g,0)==0)==size(g,2))
tmp1 = 0;
tmp2 = 1;
tmp3 = 0;
for i = 1:length(x)
    tmp1 = tmp1 + cos(x(i))^4;
    tmp2 = tmp2 * cos(x(i))^2;
    tmp3 = tmp3 + i*x(i)^2;
end
f = -abs((tmp1 - 2*tmp2) / sqrt(tmp3));
else
    f=NaN;
end
return
