function [f,g,x] = g5(x,constseq,stage)
if nargin == 0
    prob.nx = 4;
    prob.nf = 1;
    prob.ng = 5;
    prob.range = cell(1, prob.nx);
    prob.range{1} = Range('range', [0,1200]);
    prob.range{2} = Range('range', [0,1200]);
    prob.range{3} = Range('range', [-0.55,0.55]);
    prob.range{4} = Range('range', [-0.55,0.55]);
    f = prob;
else
    [f,g] = g5_true(double(x),constseq,stage);
end
return


function [f,g] = g5_true(x,constseq,stage)
eps = 1.e-5;
for i=1:size(constseq,2)
    switch constseq(i)
        case 1 
            g(1) = -x(4) + x(3) - 0.55;
        case 2
            g(2) = -x(3) + x(4) - 0.55;
        case 3
            tmp1 = 1000*sin(-x(3)-0.25) + 1000*sin(-x(4)-0.25) + 894.8 - x(1);
            g(3) = abs(tmp1) - eps;
        case 4
            tmp2 = 1000*sin(x(3)-0.25) + 1000*sin(x(3)-x(4)-0.25) + 894.8 - x(2);
            g(4) = abs(tmp2) - eps;
        case 5
            tmp3 = 1000*sin(x(4)-0.25) + 1000*sin(x(4)-x(3)-0.25) + 1294.8;
            g(5) =  abs(tmp3)-eps;
            
    end
    if(~strcmp(stage,'init') && (g(constseq(i)))>0 )
        for j=(i+1):size(constseq,2)
            g(constseq(j))=inf;
        end
        break
    end
end
%Place the objective function in below
if(sum(max(g,0)==0)==size(g,2)|| strcmp(stage,'init'))
    f = 3*x(1) + 0.000001*x(1)^3 + 2*x(2) + (0.000002/3)*x(2)^3;
else
    f=NaN;
end
return
