function [f,g,x] = g7(x,constseq,stage)
if nargin == 0
    prob.nx = 10;
    prob.nf = 1;
    prob.ng = 8;
    prob.range = cell(1, prob.nx);
    for i = 1:prob.nx
        prob.range{i} = Range('range', [-10,10]);
    end
    f = prob;
else
    [f,g] = g7_true(double(x),constseq,stage);
end
return


function [f,g] = g7_true(x,constseq,stage)

for i=1:size(constseq,2)
    switch constseq(i)
        case 1
            g(1) = -(105 - 4*x(1) - 5*x(2) + 3*x(7) - 9*x(8));
        case 2
            g(2) = -(-10*x(1) + 8*x(2) + 17*x(7) - 2*x(8));
        case 3
            g(3) = -(8*x(1) - 2*x(2) - 5*x(9) + 2*x(10) + 12);
        case 4
            g(4) = -(-3*(x(1)-2)^2 - 4*(x(2)-3)^2 - 2*x(3)^2 + 7*x(4) + 120);
        case 5
            g(5) = -(-5*x(1)^2 - 8*x(2) - (x(3)-6)^2 + 2*x(4) + 40);
        case 6
            g(6) = -(-x(1)^2 - 2*(x(2)-2)^2 + 2*x(1)*x(2) - 14*x(5) + 6*x(6));
        case 7
            g(7) = -(-0.5*(x(1)-8)^2 - 2*(x(2)-4)^2 - 3*x(5)^2 + x(6) + 30);
        case 8
            g(8) = -(3*x(1) - 6*x(2) - 12*(x(9)-8)^2 + 7*x(10));
    end
     if(~strcmp(stage,'init') && (g(constseq(i)))>0)
        for j=(i+1):size(constseq,2)
            g(constseq(j))=inf;
        end
        break
    end
end
%Place the objective function in below
if(sum(max(g,0)==0)==size(g,2))
  f = x(1)^2 + x(2)^2 + x(1)*x(2) - 14*x(1) - 16*x(2) + (x(3)-10)^2 + ...
    4*(x(4)-5)^2 + (x(5)-3)^2 + 2*(x(6)-1)^2 + 5*x(7)^2 + ...
    7*(x(8)-11)^2 + 2*(x(9)-10)^2 + (x(10)-7)^2 + 45;
else
    f=NaN;
end
return
